import psycopg2
from cherrypy.lib import auth_digest
import cherrypy
import numpy as np
import pandas as pd
import os
from os import walk
import daemon
import tarfile
import zipfile
import shutil
import gc

from datetime import datetime


htmlout = """
<!DOCTYPE html>
<html lang = "en-US">

<head>
<title>2018 PHM DATA CHALLENGE RESULTS</title>
</head>


<body>

<h2>2018 PHM Data Challenge Results</h2>

<p>Thanks to all the teams for making this a successful competition!  The winning teams are listed below:</p>

<table style="width:25%;border: 1px solid black;">
<tr>
<th style="border: 1px solid black;">Place</th>
<th style="border: 1px solid black;">Team</th>
</tr>
<tr>
<th style="border: 1px solid black;">1</th>
<th style="border: 1px solid black;">TinTin</th>
</tr>
<tr>
<th style="border: 1px solid black;">2</th>
<th style="border: 1px solid black;">HRD</th>
</tr>
<tr>
<th  style="border: 1px solid black;">3</th>
<th  style="border: 1px solid black;">iSense</th>
</tr>
</table>


</body>

</html>
"""

class RootServer:
    @cherrypy.expose
    def index(self):
        return htmlout

class SecureServer:
    @cherrypy.expose
    def index(self):
        return htmlout


if __name__ == '__main__':
    conf = {
        '/secure': {
            'tools.auth_digest.on': True,
            'tools.auth_digest.realm': '70.32.24.178:8080',
            },
        }

    root = RootServer()
    root.secure = SecureServer()

    cherrypy.config.update({'server.socket_host':'70.32.24.178'})
    cherrypy.config.update({'server.max_request_body_size':504857600})
    cherrypy.config.update({'tools.MemoryCache.delay': 5})
    
    with daemon.DaemonContext():
        cherrypy.quickstart(root,'/',conf)
    
