import psycopg2
from cherrypy.lib import auth_digest
import cherrypy
import numpy as np
import pandas as pd
import os
import subprocess

from datetime import datetime

def put_sql(sql_string):
    try:
        conn = psycopg2.connect("dbname=phmdb user=postgres password=protocolz123")
        cur = conn.cursor()
        cur.execute(sql_string)
        conn.commit()
        cur.close()
        conn.close()
        #print 'put_sql succeeded'
        return True
    except:
        #print 'put_sql failed'
        return False

def get_sql(sql_string):
    try:
        conn = psycopg2.connect("dbname=phmdb user=postgres password=protocolz123")
        cur = conn.cursor()
        cur.execute(sql_string)
        result = cur.fetchall()
        cur.close()
        conn.close()
        #print 'get_sql succeeded'
        return result
    except:
        #print 'get_sql failed'
        return None

def delete_table_data(table):
    return put_sql("DELETE FROM " + table + ";")

def get_table_data(table,columns):
    return get_sql("SELECT " + columns + " FROM " + table + ";")

def add_new_team_login(team_name, team_password):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        result_sql = put_sql("INSERT INTO login (team_name,team_password) VALUES ('%s','%s');" % (team_name,team_password,))
        if result_sql:
            print 'Added new team = ' + team_name + '.'
        else:
            print 'Failed to add new team = ' + team_name + '.'
        return result_sql
    else:
        print 'Team = ' + team_name + ' login already exists'
        return False
        
def add_new_team_contact(team_name, contact_name, contact_email, contact_affiliation):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        print 'Team = ' + team_name + ' does not exist.'
        return False
    else:
        result = get_sql("SELECT * FROM contacts WHERE team_name='" + team_name + "' AND contact_name='"+contact_name+"';")
        if result!=[]:
            print 'Name = ' + contact_name + ' already exists.'
            return False
        else:
            result_sql = put_sql("INSERT INTO contacts (team_name,contact_name,contact_email,contact_affiliation) VALUES ('%s','%s','%s','%s');" % (team_name,contact_name,contact_email,contact_affiliation,))
            if result_sql:
                print 'Added new team contact = ' + contact_name + '.'
            else:
                print 'Failed to add new team contact = ' + contact_name + '.'
            return result_sql

def add_new_team_score(team_name, score1, score2, interval_seconds):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        print 'Team = ' + team_name + ' does not exist.'
        return False
    else:
        dt = datetime.now()
        result_sql = get_sql("SELECT time_stamp FROM scores WHERE team_name='" + team_name + "' ORDER BY time_stamp DESC LIMIT 1;")
        if result_sql != []:
            diff = (dt-result_sql[0][0]).total_seconds()
            if diff < interval_seconds:
                print 'Not enough time has elapsed since last submission.'
                return diff
        result_sql = put_sql("INSERT INTO scores (team_name,time_stamp,score1,score2) VALUES ('%s','%s',%s,%s);" % (team_name,dt,score1,score2,))
        if result_sql:
            print 'Added new team score = ' + str(score1) + ',' + str(score2) + '.'
        else:
            print 'Failed to add new team = ' + team_name + '.'
        return result_sql

def get_user_password_dict():
    result_sql = get_sql("SELECT team_name,team_password FROM login;")
    if result_sql==[]:
        return None
    else:
        return dict(result_sql)

class RootServer:
    @cherrypy.expose
    def index(self):
        scores = get_table_data("scores","team_name,time_stamp,score1,score2")
        sdf = pd.DataFrame(scores)
        if sdf.empty:
            return """<head>
</head>
<body>
  <h2>2017 PHM SOCIETY DATA CHALLENGE SCORING WEBSITE</h2>
  <b>NOTE</b>: You may have to clear your browser's cache if you have login issues.<br><br>
  <h2>Validation round begins now.<br><br>
  The validation data can be downloaded here.<br>
  <a href="validation_data/data_challenge_validation.7z">Link to Data (Right Click and Save as)</a><br><br>
  You are only allowed 3 submissions per team, so choose wisely when you submit.
  The maximum validation submission score is retained from the 3 submissions.
  Each submission score will be computed based on weighting 75% accuracy and 25% sensitivity.
  Also, each team must submit a 2/3 page description of the physics-based modeling method
  utilized.<br><br>
  After the competition is closed, the final score will be calculated based on the final validation score (90% weight) and
   the description of the physics modeling approach (10% weight).<br><br>
  The validation website link is here:<br>
  <a href="http://71.51.155.29:8100">http://71.51.155.29:8100</a></h2>
  <form action="/secure">
      <input type="submit" value="Click to Login"/>
  </form>
  <h2>Latest Scores: None</h2></body>
</html>"""
        sdf.columns = ['team_name','time_stamp','accuracy','sensitivity']
        sdf_group = sdf.groupby('team_name')
        sdf_sort = sdf_group.apply(lambda x: x.sort_values(by=['time_stamp'],ascending=False).iloc[0,:]).reset_index(drop=True)
        sdf_accuracy = sdf_sort[['team_name','accuracy','time_stamp']].sort_values(by=['accuracy'],ascending=False).reset_index(drop=True)
        sdf_accuracy.index = range(1,len(sdf_accuracy)+1)
        sdf_accuracy.index.name = 'rank'
        sdf_accuracy.columns = ['team_name','accuracy','time_stamp']
        sdf_sensitivity = sdf_sort[['team_name','sensitivity','time_stamp']].sort_values(by=['sensitivity'],ascending=False).reset_index(drop=True)
        sdf_sensitivity.index = range(1,len(sdf_sensitivity)+1)
        sdf_sensitivity.index.name = 'rank'
        sdf_sensitivity.columns = ['team_name','sensitivity','time_stamp']
        sdf_accuracy_html = sdf_accuracy.to_html(col_space=150,justify='left')
        sdf_sensitivity_html = sdf_sensitivity.to_html(col_space=150,justify='left')
        return """
<html>
<head>
</head>
<body>
  <h2>2017 PHM SOCIETY DATA CHALLENGE SCORING WEBSITE</h2>
  <b>NOTE</b>: You may have to clear your browser's cache if you have login issues.<br><br>
  <h2>Validation round begins now.<br><br>
  The validation data can be downloaded here.<br>
  <a href="validation_data/data_challenge_validation.7z">Link to Data (Right Click and Save as)</a><br><br>
  You are only allowed 3 submissions per team, so choose wisely when you submit.
  The maximum validation submission score is retained from the 3 submissions.
  Each submission score will be computed based on weighting 75% accuracy and 25% sensitivity.
  Also, each team must submit a 2/3 page description of the physics-based modeling method
  utilized.<br><br>
  After the competition is closed, the final score will be calculated based on the final validation score (90% weight) and
   the description of the physics modeling approach (10% weight).<br><br>
  The validation website link is here:<br>
  <a href="http://71.51.155.29:8100">http://71.51.155.29:8100</a></h2>
  <form action="/secure">
      <input type="submit" value="Click to Login"/>
  </form>
  <h2>Latest Scores</h2><div style="display: inline-block;background-color: LightCyan;">""" + sdf_accuracy_html + """</div><div style="display: inline-block;background-color: SeaShell;">""" + sdf_sensitivity_html + """</div>
</body>
</html>
"""

class SecureServer:
    @cherrypy.expose
    def index(self):
        user_login = cherrypy.request.login
        scores = get_table_data("scores","team_name,time_stamp,score1,score2")
        sdf = pd.DataFrame(scores)
        if sdf.empty:
            return """<html><head><script src="https://cdn.plot.ly/plotly-1.2.0.min.js"></script></head><body>
<h2>Submit a File</h2>
<form action="upload" method="post" enctype="multipart/form-data">
<input type="file" name="myFile" /><br/><br>
<input type="submit"/>
</form>
  <h2>Latest Scores: None</h2>
</html>"""
        sdf.columns = ['team_name','time_stamp','accuracy','sensitivity']
        sdf_group = sdf.groupby('team_name')
        sdf_sort = sdf_group.apply(lambda x: x.sort_values(by=['time_stamp'],ascending=False).iloc[0,:]).reset_index(drop=True)
        sdf_accuracy = sdf_sort[['team_name','accuracy','time_stamp']].sort_values(by=['accuracy'],ascending=False).reset_index(drop=True)
        sdf_accuracy.index = range(1,len(sdf_accuracy)+1)
        sdf_accuracy.index.name = 'rank'
        sdf_accuracy.columns = ['team_name','accuracy','time_stamp']
        sdf_sensitivity = sdf_sort[['team_name','sensitivity','time_stamp']].sort_values(by=['sensitivity'],ascending=False).reset_index(drop=True)
        sdf_sensitivity.index = range(1,len(sdf_sensitivity)+1)
        sdf_sensitivity.index.name = 'rank'
        sdf_sensitivity.columns = ['team_name','sensitivity','time_stamp']
        sdf_accuracy_html = sdf_accuracy.to_html(col_space=150,justify='left')
        sdf_sensitivity_html = sdf_sensitivity.to_html(col_space=150,justify='left')

        # display score
        scores = get_table_data("scores","team_name,time_stamp,score1,score2")
        sdf = pd.DataFrame(scores)
        sdf.columns = ['team_name','time_stamp','score1','score2']
        sdf = sdf[sdf['team_name']==user_login].sort_values(by=['time_stamp'],ascending=True).reset_index(drop=True)
        Y1 = list(sdf['score1'].values)
        Y2 = list(sdf['score2'].values)
        #if (len(Y1) > 50):
            #Y1 = Y1[len(Y1)-50:len(Y1)-1]
            #Y2 = Y2[len(Y2)-50:len(Y2)-1]
        X = [i for i in range(0,len(Y1))]
        out = """<br><br><h2>TEAM: """ + user_login + """</h2><h2>Accuracy</h2><div id="tester1" style="width:800px;height:300px;"></div>
                <h2>Sensitivity</h2>
                <div id="tester2" style="width:800px;height:300px;"></div>
		<script>
		TESTER1 = document.getElementById('tester1');
		Plotly.plot(TESTER1, [{
		x:""" + str(X) + """, y: """ + str(Y1) + """}], {
		margin: {t:0}});
		TESTER2 = document.getElementById('tester2');
		Plotly.plot(TESTER2, [{
		x:""" + str(X) + """, y: """ + str(Y2) + """}], {
		margin: {t:0}});</script>
                """

        return """
<html><head><script src="https://cdn.plot.ly/plotly-1.2.0.min.js"></script></head><body>
<h2>Submit a File</h2>
<form action="upload" method="post" enctype="multipart/form-data">
<input type="file" name="myFile" /><br/><br>
<input type="submit"/>
</form>
  <h2>Latest Scores</h2><div style="display: inline-block;background-color: LightCyan;">""" + sdf_accuracy_html + """</div><div style="display: inline-block;background-color: SeaShell;">""" + sdf_sensitivity_html + """</div>""" + out + """
</body>
</html>
"""


    @cherrypy.expose
    def upload(self, myFile):

        # submission interval time (seconds)
        time_interval = 60*60*24 #60*60*24*7

        # ground truth file path
        gt_file_path = "testing-check.csv"

	# create directory for temporary submitted data file if not existing
        user_login = cherrypy.request.login
        dir_path = 'submissions/' + user_login
        file_name = 'tmp.csv'
        file_path = dir_path + '/' + file_name
        if not os.path.isdir(dir_path):
            os.makedirs(dir_path)

        # copy submitted data to temporary file
        try:
            file_data = myFile.file.read()
        except:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Please select a file.</h2>
	            <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                   """
        f = open(file_path,'w')
        file_data = file_data.replace('\0','')
        file_data = file_data.replace('\r','')
        print repr(file_data)
        f.write(file_data)
        f.close()

        # load ground truth data
        ground_truth = pd.read_csv(gt_file_path)

        # load submitted data
        try:
            submitted_data = pd.read_csv(file_path)
        except:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Incorrect File Format</h2>
	            <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                   """

        # bad file check
        bad_file = False
        print ground_truth.shape
        print submitted_data.shape
        bad_file = bad_file | (ground_truth.shape[0] != 200)
        bad_file = bad_file | (ground_truth.shape[1] != 7)
        bad_file = bad_file | (submitted_data.shape[0] != 200)
        bad_file = bad_file | (submitted_data.shape[1] != 2)
        #bad_file = (ground_truth.shape != submitted_data.shape)
        if bad_file:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Incorrect File Format</h2>
	            <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                   """

        
        # calculate scores
        x = "calculate_score " + gt_file_path + " " + file_path
        output = subprocess.check_output(x,shell=True)
        print output
        output = output.replace(' ','').replace('\r','').split('\n')
        print output

        score1 = float(output[0].split('=')[1])
        score2 = float(output[1].split('=')[1])
        screen_output = output[2]

        # check if not enough time has elapsed since last submission
        result = add_new_team_score(user_login,score1,score2,time_interval)

        # is it a float, if so not enough time has elapsed
        if isinstance(result,float):
            out =   """<html>
                    <head></head>
                    <body>
                    <h2>Not enough time has elapsed since last submission. """
            if (time_interval-result > 86400):
                out += """Days remaining: """ + "{:5.1f}".format(float(time_interval-result)/86400.0) + """</h2>"""
            elif (time_interval-result > 3600):
                out += """Hours remaining: """ + "{:5.1f}".format(float(time_interval-result)/3600.0) + """</h2>"""
            elif (time_interval-result > 60):
                out += """Minutes remaining: """ + "{:5.1f}".format(float(time_interval-result)/60.0) + """</h2>"""
            else:
                out += """Seconds remaining: """ + "{:5.1f}".format(float(time_interval-result)) + """</h2>"""
            out += """<br><form action="/secure">
	 	      <input type="submit" value="Back"/>
	              </form></body></html>"""
            return out

        
        # if some error occurred in sql transaction
        if not result:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Error submitting score.</h2>
               	    <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                    """

        # display score
        scores = get_table_data("scores","team_name,time_stamp,score1,score2")
        sdf = pd.DataFrame(scores)
        print scores
        print sdf
        sdf.columns = ['team_name','time_stamp','score1','score2']
        sdf = sdf[sdf['team_name']==user_login].sort_values(by=['time_stamp'],ascending=True).reset_index(drop=True)
        Y1 = list(sdf['score1'].values)
        Y2 = list(sdf['score2'].values)
        #if (len(Y1) > 50):
            #Y1 = Y1[len(Y1)-50:len(Y1)-1]
            #Y2 = Y2[len(Y2)-50:len(Y2)-1]
        X = [i for i in range(0,len(Y1))]
        out = """
                <html>
                <head><script src="https://cdn.plot.ly/plotly-1.2.0.min.js"></script></head>
                <body>
                <h2>Accuracy = """ + str(score1) + """</h2>
		<div id="tester1" style="width:800px;height:300px;"></div>
                <h2>Sensitivity = """ + str(score2) + """</h2>
                <div id="tester2" style="width:800px;height:300px;"></div>
                <div><p>""" + screen_output + """</p></div>
		<script>
		TESTER1 = document.getElementById('tester1');
		Plotly.plot(TESTER1, [{
		x:""" + str(X) + """, y: """ + str(Y1) + """}], {
		margin: {t:0}});
		TESTER2 = document.getElementById('tester2');
		Plotly.plot(TESTER2, [{
		x:""" + str(X) + """, y: """ + str(Y2) + """}], {
		margin: {t:0}});
		</script>
	        <form action="/secure">
	 	<input type="submit" value="Back"/>
	        </form>
                </body>
                </html>
                """
        return out

 

if __name__ == '__main__':
    #delete_table_data('login')
    #delete_table_data('contacts')
    #delete_table_data('scores')
    
    #add_new_team_login("jpropes","pecansam11")
    #add_new_team_login("mpropes","pecansam11")
    #add_new_team_contact("npropes","Nicholas Propes","npropes@gmail.com","Seagate")
    #add_new_team_score("npropes",0.123,60)

    user_pass_list = get_user_password_dict()

    conf = {
        '/secure': {
            'tools.auth_digest.on': True,
            'tools.auth_digest.realm': '71.51.155.85:8080',
            'tools.auth_digest.get_ha1': auth_digest.get_ha1_dict_plain(user_pass_list),
            'tools.auth_digest.key': 'f433b27146791cfa'
            },
        '/validation_data': {
            'tools.staticdir.on' : True,
            'tools.staticdir.dir' : 'C:\\Users\\nprop\\Desktop\\phm\\validation_data',
            }
        }

    root = RootServer()
    root.secure = SecureServer()

    cherrypy.config.update({'server.socket_host':'192.168.0.33'})
    cherrypy.config.update({'tools.MemoryCache.delay': 5})
    cherrypy.quickstart(root,'/',conf)
    
