import psycopg2
from cherrypy.lib import auth_digest
import cherrypy
import numpy as np
import pandas as pd
import os
import daemon

from datetime import datetime

def put_sql(sql_string):
    try:
        conn = psycopg2.connect("dbname=npropes user=npropes password=protocolz123")
        cur = conn.cursor()
        cur.execute(sql_string)
        conn.commit()
        cur.close()
        conn.close()
        print 'put_sql succeeded'
        return True
    except:
        print 'put_sql failed'
        return False

def get_sql(sql_string):
    try:
        conn = psycopg2.connect("dbname=npropes user=npropes password=protocolz123")
        cur = conn.cursor()
        cur.execute(sql_string)
        result = cur.fetchall()
        cur.close()
        conn.close()
        print 'get_sql succeeded'
        return result
    except:
        print 'get_sql failed'
        return None

def delete_table_data(table):
    return put_sql("DELETE FROM " + table + ";")

def get_table_data(table):
    return get_sql("SELECT * FROM " + table + ";")

def add_new_team_login(team_name, team_password):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        result_sql = put_sql("INSERT INTO login (team_name,team_password) VALUES ('%s','%s');" % (team_name,team_password,))
        if result_sql:
            print 'Added new team = ' + team_name + '.'
        else:
            print 'Failed to add new team = ' + team_name + '.'
        return result_sql
    else:
        print 'Team = ' + team_name + ' login already exists'
        return False
        
def add_new_team_contact(team_name, contact_name, contact_email, contact_affiliation):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        print 'Team = ' + team_name + ' does not exist.'
        return False
    else:
        result = get_sql("SELECT * FROM contacts WHERE team_name='" + team_name + "' AND contact_name='"+contact_name+"';")
        if result!=[]:
            print 'Name = ' + contact_name + ' already exists.'
            return False
        else:
            result_sql = put_sql("INSERT INTO contacts (team_name,contact_name,contact_email,contact_affiliation) VALUES ('%s','%s','%s','%s');" % (team_name,contact_name,contact_email,contact_affiliation,))
            if result_sql:
                print 'Added new team contact = ' + contact_name + '.'
            else:
                print 'Failed to add new team contact = ' + contact_name + '.'
            return result_sql

def add_new_team_score(team_name, score, interval_seconds):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        print 'Team = ' + team_name + ' does not exist.'
        return False
    else:
        dt = datetime.now()
        result_sql = get_sql("SELECT time_stamp FROM scores WHERE team_name='" + team_name + "' ORDER BY time_stamp DESC LIMIT 1;")
        if result_sql != []:
            diff = (dt-result_sql[0][0]).total_seconds()
            if diff < interval_seconds:
                print 'Not enough time has elapsed since last submission.'
                return diff
        result_sql = put_sql("INSERT INTO scores (team_name,time_stamp,score) VALUES ('%s','%s',%s);" % (team_name,dt,score,))
        if result_sql:
            print 'Added new team score = ' + str(score) + '.'
        else:
            print 'Failed to add new team = ' + team_name + '.'
        return result_sql

def get_user_password_dict():
    result_sql = get_sql("SELECT team_name,team_password FROM login;")
    if result_sql==None:
        return None
    else:
        return dict(result_sql)

class RootServer:
    @cherrypy.expose
    def index(self):
        scores = get_table_data("scores")
        print scores
        sdf = pd.DataFrame(scores)
        sdf.columns = ['team_name','time_stamp','score']
        sdf_group = sdf.groupby('team_name')
        sdf_sort = sdf_group.apply(lambda x: x.sort_values(by=['time_stamp'],ascending=False).iloc[0,:]).reset_index(drop=True)
        sdf_score = sdf_sort[['team_name','score']].sort_values(by=['score'],ascending=False).reset_index(drop=True)
        sdf_score.index = range(1,len(sdf_score)+1)
        sdf_score.index.name = 'rank'
        sdf_score = sdf_score.reset_index(drop=False)   
        sdf_score_html = sdf_score.to_html(col_space=150,justify='left',index=False)
        return """
<html>
<head>
</head>
<body>
  <h2>2018 PHM SOCIETY DATA CHALLENGE SCORING WEBSITE</h2>
  <b>NOTE</b>: You may have to clear your browser's cache if you have login issues.<br><br>
  <form action="/secure">
      <input type="submit" value="Click to Login"/>
  </form>
  <h2>Latest Scores</h2><div style="display: inline-block;background-color: LightCyan;">""" + sdf_score_html + """</div>
</body>
</html>
"""

class SecureServer:
    @cherrypy.expose
    def index(self):
        user_login = cherrypy.request.login
        scores = get_table_data("scores")
        sdf = pd.DataFrame(scores)
        sdf.columns = ['team_name','time_stamp','score']
        sdf_group = sdf.groupby('team_name')
        sdf_sort = sdf_group.apply(lambda x: x.sort_values(by=['time_stamp'],ascending=False).iloc[0,:]).reset_index(drop=True)
        sdf_score = sdf_sort[['team_name','score']].sort_values(by=['score'],ascending=False).reset_index(drop=True)
        sdf_score.index = range(1,len(sdf_score)+1)
        sdf_score.index.name = 'rank'
        sdf_score = sdf_score.reset_index(drop=False)   
        sdf_score_html = sdf_score.to_html(col_space=150,justify='left',index=False)

        # display score
        scores = get_table_data("scores")
        sdf = pd.DataFrame(scores)
        sdf.columns = ['team_name','time_stamp','score']
        sdf = sdf[sdf['team_name']==user_login].sort_values(by=['time_stamp'],ascending=True).reset_index(drop=True)
        Y1 = list(sdf['score'].values)
        X = [i for i in range(0,len(Y1))]
        out = """<br><br><h2>TEAM: """ + user_login + """</h2><h2>Score</h2><div id="tester1" style="width:800px;height:300px;"></div>
		<script>
		TESTER1 = document.getElementById('tester1');
		Plotly.plot(TESTER1, [{
		x:""" + str(X) + """, y: """ + str(Y1) + """}], {
		margin: {t:0}});</script>
                """
        return """
<html><head><script src="https://cdn.plot.ly/plotly-1.2.0.min.js"></script></head><body>
<h2>Submit a File</h2>
<form action="upload" method="post" enctype="multipart/form-data">
<input type="file" name="myFile" /><br/><br>
<input type="submit"/>
</form>
  <h2>Latest Scores</h2><div style="display: inline-block;background-color: LightCyan;">""" + sdf_score_html + """</div>""" + out + """
</body>
</html>
"""


    @cherrypy.expose
    def upload(self, myFile):

        # submission interval time (seconds)
        time_interval = 30 #60*60*24*7

        # ground truth file path
        gt_file_path = '/home/npropes/phm/ground_truth/gt.csv'

	# create directory for temporary submitted data file if not existing
        user_login = cherrypy.request.login
        dir_path = '/home/npropes/phm/submissions/' + user_login
        file_name = 'tmp.csv'
        file_path = dir_path + '/' + file_name
        if not os.path.isdir(dir_path):
            os.makedirs(dir_path)

        # copy submitted data to temporary file
        try:
            file_data = myFile.file.read()
        except:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Please select a file.</h2>
	            <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                   """
        f = open(file_path,'w')
        f.write(file_data)
        f.close()

        # load ground truth data
        ground_truth = pd.read_csv(gt_file_path)

        # load submitted data
        try:
            submitted_data = pd.read_csv(file_path)
        except:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Incorrect File Format</h2>
	            <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                   """

        # bad file check
        bad_file = False
        bad_file = (ground_truth.shape != submitted_data.shape)
        if bad_file:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Incorrect File Format</h2>
	            <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                   """

        # calculate score
        score = 5

        # check if not enough time has elapsed since last submission
        result = add_new_team_score(user_login,score,time_interval)

        # is it a float, if so not enough time has elapsed
        if isinstance(result,float):
            out =   """<html>
                    <head></head>
                    <body>
                    <h2>Not enough time has elapsed since last submission. """
            if (time_interval-result > 86400):
                out += """Days remaining: """ + "{:5.1f}".format(float(time_interval-result)/86400.0) + """</h2>"""
            elif (time_interval-result > 3600):
                out += """Hours remaining: """ + "{:5.1f}".format(float(time_interval-result)/3600.0) + """</h2>"""
            elif (time_interval-result > 60):
                out += """Minutes remaining: """ + "{:5.1f}".format(float(time_interval-result)/60.0) + """</h2>"""
            else:
                out += """Seconds remaining: """ + "{:5.1f}".format(float(time_interval-result)) + """</h2>"""
            out += """<br><form action="/secure">
	 	      <input type="submit" value="Back"/>
	              </form></body></html>"""
            return out

        
        # if some error occurred in sql transaction
        if not result:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Error submitting score.</h2>
               	    <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                    """

        # display score
        scores = get_table_data("scores")
        sdf = pd.DataFrame(scores)
        sdf.columns = ['team_name','time_stamp','score']
        sdf = sdf[sdf['team_name']==user_login].sort_values(by=['time_stamp'],ascending=True).reset_index(drop=True)
        Y1 = list(sdf['score'].values)
        X = [i for i in range(0,len(Y1))]
        out = """<html>
                <head><script src="https://cdn.plot.ly/plotly-1.2.0.min.js"></script></head>
                <h2>Score = """ + str(score) + """</h2>
		<div id="tester1" style="width:800px;height:300px;"></div>
                <body>
		<script>
		TESTER1 = document.getElementById('tester1');
		Plotly.plot(TESTER1, [{
		x:""" + str(X) + """, y: """ + str(Y1) + """}], {
		margin: {t:0}});</script>
		<form action="/secure">
	 	<input type="submit" value="Back"/>
	        </form>
                </body>
                </html>
                """
        return out

 

if __name__ == '__main__':
    #delete_table_data('login')
    #delete_table_data('contacts')
    #delete_table_data('scores')
    
    #add_new_team_login("npropes3","pecansam")
    #add_new_team_contact("npropes3","Nicholas Propes","npropes@gmail.com","Seagate")
    #add_new_team_score("npropes3",0.231,60)

    user_pass_list = get_user_password_dict()

    conf = {
        '/secure': {
            'tools.auth_digest.on': True,
            'tools.auth_digest.realm': '70.32.24.178:8080',
            'tools.auth_digest.get_ha1': auth_digest.get_ha1_dict_plain(user_pass_list),
            'tools.auth_digest.key': 'f333b27146791cfa'
            },
        }

    root = RootServer()
    root.secure = SecureServer()

    cherrypy.config.update({'server.socket_host':'70.32.24.178'})
    cherrypy.config.update({'tools.MemoryCache.delay': 5})
    
    with daemon.DaemonContext():
        cherrypy.quickstart(root,'/',conf)
    
